namespace sGUI

declare function AddArrow (event as EventHandle ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
declare function AddSmallArrow (event as EventHandle ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
declare function ArrowActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawArrow (gad as Gadget ptr)
declare sub DrawSmallArrow (gad as Gadget ptr)

'Steuerungsvariablen:
'Ctrl(0) enthlt einen Richtungsmarker 0=links,1=rechts,2=hoch,3=runter
'Ctrl(1) wird fr die Zeitverzgerung des Triggerns bentigt
function AddArrow (event as EventHandle ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    if DirArrow=0 or DirArrow=1 then
      gad->gadw=16
      gad->gadh=15
    end if
    if DirArrow=2 or DirArrow=3 then
      gad->gadw=15
      gad->gadh=16
    end if

    gad->Ctrl(0)=DirArrow

    gad->DoDraw     =@DrawArrow
    gad->DoAction   =@ArrowActions
    gad->DoUpdate   =@DrawArrow

		gad->SaveBackGround
		function=gad
  end if
end function



function AddSmallArrow (event as EventHandle ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    if DirArrow=0 or DirArrow=1 then
      gad->gadw=10
      gad->gadh=9
    end if
    if DirArrow=2 or DirArrow=3 then
      gad->gadw=9
      gad->gadh=10
    end if

    gad->Ctrl(0)=DirArrow

    gad->DoDraw     =@DrawSmallArrow
    gad->DoAction   =@ArrowActions

		gad->SaveBackGround
		function=gad
  end if
end function



function ArrowActions(gad as Gadget ptr,action as integer) as integer
  function=0
  static as single tt

  select case action

      case GADGET_HIT        'Control grad frisch gedrckt
        SetSelect (gad,1)
        function=1
      
      case GADGET_HOLD       'Control wird gehalten, Maus ber dem Control
        if gad->Ctrl(1)=2 and timer >= tt+.05 then
          tt=timer
          function=1
        end if

        if gad->Ctrl(1)=1 and timer >= tt+.8 then
          tt=timer
          gad->Ctrl(1)=2
          function=1
        end if

        if gad->Ctrl(1)=0 then
          tt=timer
          gad->Ctrl(1)=1
        end if
      case GADGET_HOLDOFF    'Control wird gehalten, Maus neben dem Control

      case GADGET_RELEASE,GADGET_RELEASEOFF    'Control regulr losgelassen/ Control losgelassen, dabei ist Maus neben dem Control
        gad->Ctrl(1)=0
        SetSelect (gad,0)
  end select
end function


sub DrawArrow (gad as Gadget ptr)
	dim as integer i,PosX,PosY,GadWidth,GadHeight,DirArrow,o
  PosX   =gad->posx
	PosY   =gad->posy
	GadWidth		=gad->gadw
	GadHeight		=gad->gadh
  DirArrow   =gad->Ctrl(0)
  screenlock
    if gad->act=0 then
'OFF
      put(PosX,PosY),gad->Background,pset
    else
'ON
      FrameB PosX, PosY, GadWidth, GadHeight,gad->sel
      FillA PosX+1,PosY+1,GadWidth-2,GadHeight-2,GadgetColor,gad->sel

      if gad->sel then o=1 else o=0
      if DirArrow=0 then Arrow PosX+5-o,PosY+3,4,DirArrow,GadgetTextColor
      if DirArrow=1 then Arrow PosX+5+o,PosY+3,4,DirArrow,GadgetTextColor
      if DirArrow=2 then Arrow PosX+3,PosY+5-o,4,DirArrow,GadgetTextColor
      if DirArrow=3 then Arrow PosX+3,PosY+5+o,4,DirArrow,GadgetTextColor
  'SLEEP
      if gad->act=2 then put(PosX,PosY),gad->Background,alpha,SleepShade
    end if
  screenunlock
end sub



sub DrawSmallArrow (gad as Gadget ptr)
	dim as integer i,PosX,PosY,GadWidth,GadHeight,DirArrow,o
  PosX   =gad->posx
	PosY   =gad->posy
	GadWidth		=gad->gadw
	GadHeight		=gad->gadh
  DirArrow   =gad->Ctrl(0) 
  screenlock
    if gad->act=0 then
'OFF
      put(PosX,PosY),gad->Background,pset
    else
'ON
      FrameB PosX, PosY, GadWidth, GadHeight,gad->sel
      FillA PosX+1,PosY+1,GadWidth-2,GadHeight-2,GadgetColor,gad->sel

      if gad->sel then o=1 else o=0
      if DirArrow=0 then Arrow PosX+3-o,PosY+2,2,DirArrow,GadgetTextColor
      if DirArrow=1 then Arrow PosX+3+o,PosY+2,2,DirArrow,GadgetTextColor
      if DirArrow=2 then Arrow PosX+2,PosY+3-o,2,DirArrow,GadgetTextColor
      if DirArrow=3 then Arrow PosX+2,PosY+3+o,2,DirArrow,GadgetTextColor
'SLEEP
      if gad->act=2 then put(PosX,PosY),gad->Background,alpha,SleepShade
    end if
  screenunlock  
end sub

end namespace