#include once "ListBox_Basis.bas"
#include once "ScrollBar.bas"

namespace sGUI

declare function AddListBox (event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer,NumRows as integer,DisplayMode as integer=0,ScrollBarMode as integer=0) as Gadget ptr
declare function ListActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawList (gad as Gadget ptr)
declare sub UpdateLB(gad as Gadget ptr)

declare function GetListBoxVal(gad as Gadget ptr) as integer
declare sub SetListBoxVal(gad as Gadget ptr,i as integer)

'Ctrl(1) DisplayMode 0="Normale Darstellung", 1=String ist nach Label und Item zu unterscheiden
'Ctrl(2) Anzahl Zeilen, fr das Wheelscrolling
'Ctrl(15) wenn 1 wird ein Ping gegeben
function AddListBox(event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer,NumRows as integer,DisplayMode as integer=0,ScrollBarMode as integer=0) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    gad->gadw=NumChars*8 + 6 + 15 '6 >> Rand innerhalb MLEB,  15>> Breite ScrollBar rechts
    gad->gadh=fontheight*NumRows + 6'6 >> Rand innerhalb MLEB

    gad->Ctrl(1)=DisplayMode
    gad->Ctrl(2)=NumRows
    
    gad->subevent=new EventHandle
    if gad->subevent then
      gad->gad(0)=AddLBGadget(gad->subevent,PosX,PosY,NumChars,NumRows,DisplayMode)
    	gad->gad(1)=AddScrollBar(gad->subevent,PosX+NumChars*8 + 6,PosY,NumRows*fontheight+6,1,1,1,NumRows,1,ScrollBarMode)
		end if

    gad->extTObject=gad->gad(0)->TObject'Verbindung zum Textobjekt erzeugen das eigentlich zur LB in gad(0) gehrt
    gad->useextTO=1                     'Flag fr alle TO-Befehle extTObject zu benutzen

    gad->DoDraw     =@DrawList
    gad->DoAction   =@ListActions
    gad->DoUpdate   =@UpdateLB

		'gad->SaveBackGround
		function=gad
  end if
end function



function ListActions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as integer enable
  select case action
    case GADGET_HIT,GADGET_HOLD,GADGET_HOLDOFF,GADGET_RELEASE,GADGET_RELEASEOFF
      gad->subevent->GadgetControl
      gad->Ctrl(15)=0
      if gad->subevent->GADGETMESSAGE then
        select case gad->subevent->GADGETMESSAGE
          case gad->gad(0)
            gad->Ctrl(15)=1
          case gad->gad(1)
            VScrollLB(gad->gad(0),GetScrollBarVal(gad->gad(1)))
            DrawGadget(gad->gad(0))
        end select
      end if        
      if gad->Ctrl(15) then function=1
    case GADGET_WHEELMOVE
      ModifyScrollBar(gad->gad(1),GetScrollBarVal( gad->gad(1) ) + WHEEL*(gad->Ctrl(2)-1) )
      VScrollLB(gad->gad(0),GetScrollBarVal(gad->gad(1)))
      DrawGadget(gad->gad(0))      
  end select
end function



sub DrawList (gad as Gadget ptr)
  DrawGadget(gad->gad(0))
end sub



sub UpdateLB(gad as Gadget ptr)
  gad->gad(0)->Ctrl(15)=0'Selektion in LB aufheben
  ModifyScrollBar(gad->gad(1),1,TO_GetLines(gad),1)
  VScrollLB(gad->gad(0),1)
  DrawGadget(gad->gad(0))
end sub



function GetListBoxVal(gad as Gadget ptr) as integer
  if gad->Ctrl(1) then
    function=gad->gad(0)->Ctrl(14)
  else
    function=gad->gad(0)->Ctrl(15)
  end if
end function



sub SetListBoxVal(gad as Gadget ptr,i as integer)
  dim as integer l,lcount,found
  dim as string lc,header
  dim as integer itemid
  dim as integer spos
  l=TO_GetLines(gad)
  'im DisplayMode 1 steht i fr die item ID nachder in allen Zeilen des TOs gesucht wird
  'wird die Zeile gefunden

  'im DisplayMode 0 entsprich i direkt der Zeile

  if gad->Ctrl(1) then              'DisplayMode 1
    if l then
      lcount=1
      found=0
      do
        lc=TO_GetLineContent(gad,lcount)
        header=left(lc,3)
        if header="ITM" then
          itemid=val(mid(lc,5,3))
          if itemid=i then found=lcount
        end if
        lcount +=1
      loop until (lcount>l) or (found>0)
      'found ist die Zeilennummer in der i als Item ID definiert ist
      if found then
        gad->gad(0)->Ctrl(14)=i
        gad->gad(0)->Ctrl(15)=found
        ModifyScrollBar(gad->gad(1),found)
        VScrollLB(gad->gad(0),GetScrollBarVal(gad->gad(1)))
        DrawGadget(gad)
      end if
    end if

  else                              'DisplayMode 0

    if i<1 then i=1
    if i>l then i=l
    gad->gad(0)->Ctrl(15)=i
    ModifyScrollBar(gad->gad(1),i)
    VScrollLB( gad->gad(0) , GetScrollBarVal(gad->gad(1)) )
    DrawGadget(gad)
  end if
end sub

end namespace
