#include once "SimpleGadget.bas"

namespace sGUI

'InitGFX m u s s aufgerufen worden sein
declare function MessageBox(PosX as integer,PosY as integer,MsgText as string="",TitleText as string="",MsgType as integer=1) as integer

'Konstanten fr MessageBoxen
'Typen:
'MBType_OK=1
'MBType_YESNO=2
'MBType_CANCELRETRYIGNORE=3
'MBType_OKCANCEL=4
'MBType_RETRYCANCEL=5
'MBType_YESNOCANCEL=6

'Button Returnwerte
'MBButton_OK=1
'MBButton_CANCEL=2
'MBButton_RETRY=3
'MBButton_IGNORE=4
'MBButton_YES=5
'MBButton_NO=6

function MessageBox(PosX as integer,PosY as integer,MsgText as string="",TitleText as string="",MsgType as integer=1) as integer
  function=0

  if MsgType<1 then MsgType=1
  if MsgType>6 then MsgType=6

  dim as TextObject ptr t
  dim as integer l,ll,boxw,boxh,result,bw,bh,bs
  dim as EventHandle ptr event
  dim as Gadget ptr ok,yes,no,cancel,retry,ignore
  bw=100
  bh=20
  bs=10

  t=new TextObject

  if t then
    t->SetText(MsgText,"|")
    l =t->GetLines
    ll=t->GetLongestLine
    boxw=ll*8 + 16
    boxh=bh + (l+1)*fontheight + bh + 2*bs + 2
    if boxw<3*bw+4*bs then boxw=3*bw+4*bs

    dim as integer ptr gfxbackup
    gfxbackup=imagecreate(boxw,boxh)
    if gfxbackup then
      get (PosX,PosY)-(PosX+boxw-1,PosY+boxh-1),gfxbackup

      FillA(PosX,PosY,boxw,boxh,GadgetColor,0)
      draw string (PosX+5, PosY+3),TitleText,TextColor
      FrameB(PosX+2,PosY+20,boxw-4,boxh-20-2,1)
      for i as integer=1 to l
        draw string (PosX+8, PosY+20+fontheight/2+(i-1)*fontheight),t->GetLineContent(i),TextColor
      next i

      event=new EventHandle

      select case MsgType
        case MBType_OK
          ok=AddSimpleGadget(event,PosX+boxw-bw-bs,PosY+boxh-bs-bh,bw,bh,phrase_ok)
          GadgetOn(ok)

        case MBType_YESNO
          yes=AddSimpleGadget(event,PosX+boxw-2*bw-2*bs,PosY+boxh-bs-bh,bw,bh,phrase_yes)
          no=AddSimpleGadget(event,PosX+boxw-bw-bs,PosY+boxh-bs-bh,bw,bh,phrase_no)
          GadgetOn(yes,no)

        case MBType_CANCELRETRYIGNORE
          cancel=AddSimpleGadget(event,PosX+boxw-3*bw-3*bs,PosY+boxh-bs-bh,bw,bh,phrase_cancel)
          retry=AddSimpleGadget(event,PosX+boxw-2*bw-2*bs,PosY+boxh-bs-bh,bw,bh,phrase_retry)
          ignore=AddSimpleGadget(event,PosX+boxw-bw-bs,PosY+boxh-bs-bh,bw,bh,phrase_ignore)
          GadgetOn(cancel,ignore)

        case MBType_OKCANCEL
          yes=AddSimpleGadget(event,PosX+boxw-2*bw-2*bs,PosY+boxh-bs-bh,bw,bh,phrase_yes)
          cancel=AddSimpleGadget(event,PosX+boxw-bw-bs,PosY+boxh-bs-bh,bw,bh,phrase_cancel)
          GadgetOn(yes,cancel)

        case MBType_RETRYCANCEL
          retry=AddSimpleGadget(event,PosX+boxw-2*bw-2*bs,PosY+boxh-bs-bh,bw,bh,phrase_retry)
          cancel=AddSimpleGadget(event,PosX+boxw-bw-bs,PosY+boxh-bs-bh,bw,bh,phrase_cancel)
          GadgetOn(retry,cancel)

        case MBType_YESNOCANCEL
          yes=AddSimpleGadget(event,PosX+boxw-3*bw-3*bs,PosY+boxh-bs-bh,bw,bh,phrase_yes)
          no=AddSimpleGadget(event,PosX+boxw-2*bw-2*bs,PosY+boxh-bs-bh,bw,bh,phrase_no)
          cancel=AddSimpleGadget(event,PosX+boxw-bw-bs,PosY+boxh-bs-bh,bw,bh,phrase_cancel)
          GadgetOn(yes,cancel)
      end select

      do
        event->xSleep(1,0)
        if event->GADGETMESSAGE then
          select case event->GADGETMESSAGE
            case ok
              result=MBButton_OK
              event->EXITEVENT=1
            
            case cancel
              result=MBButton_CANCEL
              event->EXITEVENT=1
            
            case retry
              result=MBButton_RETRY
              event->EXITEVENT=1
            
            case ignore
              result=MBButton_IGNORE
              event->EXITEVENT=1
            
            case yes
              result=MBButton_YES
              event->EXITEVENT=1
            
            case no
              result=MBButton_NO
              event->EXITEVENT=1

          end select
        end if
      loop until event->EXITEVENT
      
      function=result

      delete event

      put (PosX,PosY),gfxbackup,pset
      imagedestroy gfxbackup
    end if
    delete t
  end if
end function

end namespace
